- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ModePolicyCommonTemplate< POLICY_INTERFACE > Class Template Reference

Inheritance diagram for ModePolicyCommonTemplate< POLICY_INTERFACE >:

List of all members.

## Detailed Description

### template<class POLICY_INTERFACE>
class ModePolicyCommonTemplate< POLICY_INTERFACE >

Definition at line 66 of file modes.h.

## Public Member Functions
size_t | MinKeyLength () const
| returns smallest valid key length in bytes */
size_t | MaxKeyLength () const
| returns largest valid key length in bytes */
size_t | DefaultKeyLength () const
| returns default (recommended) key length in bytes */
size_t | GetValidKeyLength (size_t n) const
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
unsigned int | IVSize () const
| returns size of IVs used by this object
void | GetNextIV (byte *IV)
| get a secure IV for the next message
virtual IV_Requirement | IVRequirement () const=0
| returns the minimal requirement for secure IVs
## Protected Member Functions
unsigned int | BlockSize () const
virtual void | SetFeedbackSize (unsigned int feedbackSize)
virtual void | ResizeBuffers ()
virtual void | UncheckedSetKey (const NameValuePairs &params, const byte *key, unsigned int length, const byte *iv)=0
## Protected Attributes
BlockCipher * | m_cipher
SecByteBlock | m_register

## Member Function Documentation

void CipherModeBase::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[virtual, inherited]`

set or reset the key of this object

Parameters:

  | params | is used to specify Rounds, BlockSize, etc

Implements SimpleKeyingInterface.

Definition at line 27 of file modes.cpp.

References SimpleKeyingInterface::GetIVAndThrowIfInvalid().

void CipherModeBase::GetNextIV | ( | byte * | IV | ) | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented from SimpleKeyingInterface.

Reimplemented in CTR_ModePolicy.

Definition at line 32 of file modes.cpp.

References CipherModeBase::BlockSize(), StreamTransformation::IsForwardTransformation(), CipherModeBase::m_cipher, and CipherModeBase::m_register.

The documentation for this class was generated from the following file:

- modes.h